#!/usr/bin/python3
# Třídění algoritmem Quicksort
# Tato verze je optimalizovná na přímočarost: oproti Quicksortu
# z přednášky nepřehazuje prvky na místě a místo toho si je zkopíruje.
# Je tak lépe vidět, co se děje, ale stojí nás to linearně paměti navíc.

def quicksort(x):

    if len(x) <= 1:
        return x

    p = x[len(x) // 2]
    vlevo = [ a for a in x if a < p ]
    stred = [ a for a in x if a == p ]
    vpravo = [ a for a in x if a > p ]
    return quicksort(vlevo) + stred + quicksort(vpravo)
