#!/usr/bin/python3
# Binární vyhledávání

def hledej(A, x):
    # Hledá x v poli A, vrací buď pozici, nebo None

    def bin(l, r):
        # Hledá x v úseku A[l...r]
        if l > r:
            return None
        s = (l+r) // 2
        if x < A[s]:
            return bin(l, s-1)
        elif x > A[s]:
            return bin(s+1, r)
        else:
            return s

    return bin(0, len(A)-1)
