#!/usr/bin/python3
# Třídicí algoritmus Mergesort

def merge(x, y):
    """Slévání dvou setříděných posloupností."""
    i = j = 0
    out = []

    while i < len(x) and j < len(y):
        if x[i] < y[j]:
            out.append(x[i])
            i += 1
        else:
            out.append(y[j])
            j += 1

    if i < len(x):
        out.extend(x[i:])
    if j < len(y):
        out.extend(y[j:])
    return out

def mergesort(x):
    if len(x) <= 1:
        return x

    mid = len(x) // 2
    return merge(mergesort(x[:mid]), mergesort(x[mid:]))
